      SUBROUTINE EVT1AL(ISUM,LENX,LCIEVT,LCEVTR,LCEXDP,LCSURF,

     1                  NCOL,NROW,NEVTOP,IN,IOUT,IEVTCB)

C

C-----VERSION 1607 12MAY1987 EVT1AL

C     ******************************************************************

C     ALLOCATE ARRAY STORAGE FOR EVAPOTRANSPIRATION

C     ******************************************************************

C

C        SPECIFICATIONS:

C     ------------------------------------------------------------------

C     ------------------------------------------------------------------

C

C1------IDENTIFY PACKAGE.

      WRITE(IOUT,1)IN

    1 FORMAT(1H0,'EVT1 -- EVAPOTRANSPIRATION PACKAGE, VERSION 1,',

     1     ' 9/1/87',' INPUT READ FROM UNIT',I3)

C

C2------READ NEVTOP AND IEVTCB.

      READ(IN,3)NEVTOP,IEVTCB

    3 FORMAT(2I10)

C

C3------CHECK TO SEE THAT ET OPTION IS LEGAL.

      IF(NEVTOP.GE.1.AND.NEVTOP.LE.2)GO TO 200

C

C3A-----IF ILLEGAL PRINT A MESSAGE & ABORT SIMULATION.

      WRITE(IOUT,8)

    8 FORMAT(1X,'ILLEGAL ET OPTION CODE. SIMULATION ABORTING')

      STOP

C

C4------IF THE OPTION IS LEGAL THEN PRINT THE OPTION CODE.

  200 IF(NEVTOP.EQ.1) WRITE(IOUT,201)

  201 FORMAT(1X,'OPTION 1 -- EVAPOTRANSPIRATION FROM TOP LAYER')

      IF(NEVTOP.EQ.2) WRITE(IOUT,202)

  202 FORMAT(1X,'OPTION 2 -- EVAPOTRANSPIRATION FROM ONE SPECIFIED',

     1      ' NODE IN EACH VERTICAL COLUMN')

      IRK=ISUM

C

C5------IF CELL-BY-CELL TERMS TO BE SAVED THEN PRINT UNIT NUMBER.

      IF(IEVTCB.GT.0) WRITE(IOUT,203) IEVTCB

  203 FORMAT(1X,'CELL-BY-CELL FLOW TERMS WILL BE SAVED ON UNIT',I3)

C

C6------ALLOCATE SPACE FOR THE ARRAYS EVTR, EXDP AND SURF.

      LCEVTR=ISUM

      ISUM=ISUM+NCOL*NROW

      LCEXDP=ISUM

      ISUM=ISUM+NCOL*NROW

      LCSURF=ISUM

      ISUM=ISUM+NCOL*NROW

C

C7------IF OPTION 2 THEN ALLOCATE SPACE FOR THE INDICATOR ARRAY(IEVT)

      LCIEVT=ISUM

      IF(NEVTOP.NE.2)GO TO 300

      ISUM=ISUM+NCOL*NROW

C

C8------CALCULATE & PRINT AMOUNT OF SPACE USED BY ET PACKAGE.

  300 IRK=ISUM-IRK

      WRITE(IOUT,4)IRK

    4 FORMAT(1X,I8,' ELEMENTS OF X ARRAY USED FOR EVAPOTRANSPIRATION')

      ISUM1=ISUM-1

      WRITE(IOUT,5)ISUM1,LENX

    5 FORMAT(1X,I8,' ELEMENTS OF X ARRAY USED OUT OF',I8)

      IF(ISUM1.GT.LENX)WRITE(IOUT,6)

    6 FORMAT(1X,'   ***X ARRAY MUST BE MADE LARGER***')

C

C9------RETURN.

      RETURN

      END

      SUBROUTINE EVT1RP(NEVTOP,IEVT,EVTR,EXDP,SURF,DELR,DELC,

     1                  NCOL,NROW,IN,IOUT)

C

C-----VERSION 1635 24JUL1987 EVT1RP

C     ******************************************************************

C     READ EVAPOTRANSPIRATION DATA

C     ******************************************************************

C

C        SPECIFICATIONS:

C     ------------------------------------------------------------------

      CHARACTER*4 ANAME

      DIMENSION IEVT(NCOL,NROW),EVTR(NCOL,NROW),EXDP(NCOL,NROW),

     1          SURF(NCOL,NROW),ANAME(6,4),DELR(NCOL),DELC(NROW)

C

      DATA ANAME(1,1),ANAME(2,1),ANAME(3,1),ANAME(4,1),ANAME(5,1),

     1  ANAME(6,1) /'    ','    ','  ET',' LAY','ER I','NDEX'/

      DATA ANAME(1,2),ANAME(2,2),ANAME(3,2),ANAME(4,2),ANAME(5,2),

     1  ANAME(6,2) /'    ','    ','    ','  ET',' SUR','FACE'/

      DATA ANAME(1,3),ANAME(2,3),ANAME(3,3),ANAME(4,3),ANAME(5,3),

     1  ANAME(6,3) /' EVA','POTR','ANSP','IRAT','ION ','RATE'/

      DATA ANAME(1,4),ANAME(2,4),ANAME(3,4),ANAME(4,4),ANAME(5,4),

     1  ANAME(6,4) /'    ','    ','EXTI','NCTI','ON D','EPTH'/

C     ------------------------------------------------------------------

C

C1------READ FLAGS SHOWING WHETHER DATA IS TO BE REUSED.

      READ(IN,6)INSURF,INEVTR,INEXDP,INIEVT

    6 FORMAT(4I10)

C

C2------TEST INSURF TO SEE WHERE SURFACE ELEVATION COMES FROM.

      IF(INSURF.GE.0)GO TO 32

C

C2A------IF INSURF<0 THEN REUSE SURFACE ARRAY FROM LAST STRESS PERIOD

      WRITE(IOUT,3)

    3 FORMAT(1H0,'REUSING SURF FROM LAST STRESS PERIOD')

      GO TO 35

C

C3-------IF INSURF=>0 THEN CALL MODULE U2DREL TO READ SURFACE.

   32 CALL U2DREL(SURF,ANAME(1,2),NROW,NCOL,0,IN,IOUT)

C

C4------TEST INEVTR TO SEE WHERE MAX ET RATE COMES FROM.

   35 IF(INEVTR.GE.0)GO TO 37

C

C4A-----IF INEVTR<0 THEN REUSE MAX ET RATE.

      WRITE(IOUT,4)

    4 FORMAT(1H0,'REUSING EVTR FROM LAST STRESS PERIOD')

      GO TO 45

C

C5------IF INEVTR=>0 CALL MODULE U2DREL TO READ MAX ET RATE.

   37 CALL U2DREL(EVTR,ANAME(1,3),NROW,NCOL,0,IN,IOUT)

C

C6------MULTIPLY MAX ET RATE BY CELL AREA TO GET VOLUMETRIC RATE

      DO 40 IR=1,NROW

      DO 40 IC=1,NCOL

      EVTR(IC,IR)=EVTR(IC,IR)*DELR(IC)*DELC(IR)

   40 CONTINUE

C

C7------TEST INEXDP TO SEE WHERE EXTINCTION DEPTH COMES FROM

   45 IF(INEXDP.GE.0)GO TO 47

C

C7A------IF INEXDP<0 REUSE EXTINCTION DEPTH FROM LAST STRESS PERIOD

      WRITE(IOUT,5)

    5 FORMAT(1H0,'REUSING EXDP FROM LAST STRESS PERIOD')

      GO TO 48

C

C8-------IF INEXDP=>0 CALL MODULE U2DREL TO READ EXTINCTION DEPTH

   47 CALL U2DREL(EXDP,ANAME(1,4),NROW,NCOL,0,IN,IOUT)

C

C9------IF OPTION(NEVTOP) IS 2 THEN WE NEED AN INDICATOR ARRAY.

  48  IF(NEVTOP.NE.2)GO TO 50

C

C10------IF INIEVT<0 THEN REUSE LAYER INDICATOR ARRAY.

      IF(INIEVT.GE.0)GO TO 49

      WRITE(IOUT,2)

    2 FORMAT(1H0,'REUSING IEVT FROM LAST STRESS PERIOD')

      GO TO 50

C

C11------IF INIEVT=>0 THEN CALL MODULE U2DINT TO READ INDICATOR ARRAY.

   49 CALL U2DINT(IEVT,ANAME(1,1),NROW,NCOL,0,IN,IOUT)

C

C12-----RETURN

   50 RETURN

      END

      SUBROUTINE EVT1FM(NEVTOP,IEVT,EVTR,EXDP,SURF,RHS,HCOF,

     1                  IBOUND,HNEW,NCOL,NROW,NLAY)

C

C-----VERSION 1031 10APR1985 EVT1FM

C     ******************************************************************

C        ADD EVAPOTRANSPIRATION TO RHS AND HCOF

C     ******************************************************************

C

C        SPECIFICATIONS:

C     ------------------------------------------------------------------

      DOUBLE PRECISION HNEW

      DIMENSION IEVT(NCOL,NROW),EVTR(NCOL,NROW),EXDP(NCOL,NROW),

     1          SURF(NCOL,NROW),RHS(NCOL,NROW,NLAY),

     2          HCOF(NCOL,NROW,NLAY),IBOUND(NCOL,NROW,NLAY),

     3          HNEW(NCOL,NROW,NLAY)

C     ------------------------------------------------------------------

C

C1------PROCESS EACH HORIZONTAL CELL LOCATION

      DO 10 IR=1,NROW

      DO 10 IC=1,NCOL

C

C2------SET THE LAYER INDEX EQUAL TO 1      .

      IL=1

C

C3------IF OPTION 2 IS SPECIFIED THEN GET LAYER INDEX FROM IEVT ARRAY

      IF(NEVTOP.EQ.2)IL=IEVT(IC,IR)

C

C4------IF THE CELL IS EXTERNAL IGNORE IT.

      IF(IBOUND(IC,IR,IL).LE.0)GO TO 10

      C=EVTR(IC,IR)

      S=SURF(IC,IR)

      H=HNEW(IC,IR,IL)

C

C5------IF AQUIFER HEAD IS GREATER THAN OR EQUAL TO SURF, ET IS CONSTANT

      IF(H.LT.S) GO TO 5

C

C5A-----SUBTRACT -EVTR FROM RHS

      RHS(IC,IR,IL)=RHS(IC,IR,IL) + C

      GO TO 10

C

C6------IF DEPTH TO WATER>=EXTINCTION DEPTH THEN ET IS 0

    5 D=S-H

      X=EXDP(IC,IR)

      IF(D.GE.X)GO TO 10

C

C7------LINEAR RANGE. ADD ET TERMS TO BOTH RHS AND HCOF.

      RHS(IC,IR,IL)=RHS(IC,IR,IL)+C-C*S/X

      HCOF(IC,IR,IL)=HCOF(IC,IR,IL)-C/X

   10 CONTINUE

C

C8------RETURN

      RETURN

      END

      SUBROUTINE EVT1BD(NEVTOP,IEVT,EVTR,EXDP,SURF,IBOUND,HNEW,

     1           NCOL,NROW,NLAY,DELT,VBVL,VBNM,MSUM,KSTP,KPER,

     2           IEVTCB,ICBCFL,BUFF,IOUT)

C-----VERSION 1608 12MAY1987 EVT1BD

C     ******************************************************************

C     CALCULATE VOLUMETRIC BUDGET FOR EVAPOTRANSPIRATION

C     ******************************************************************

C

C        SPECIFICATIONS:

C     ------------------------------------------------------------------

      CHARACTER*4 VBNM,TEXT

      DOUBLE PRECISION HNEW

      DIMENSION IEVT(NCOL,NROW),EVTR(NCOL,NROW),EXDP(NCOL,NROW),

     1          SURF(NCOL,NROW),IBOUND(NCOL,NROW,NLAY),

     2          VBVL(4,20),VBNM(4,20),HNEW(NCOL,NROW,NLAY),

     3          BUFF(NCOL,NROW,NLAY)

      DIMENSION TEXT(4)

      DATA TEXT(1),TEXT(2),TEXT(3),TEXT(4) /'    ','    ','    ','  ET'/

C     ------------------------------------------------------------------

C

C1------CLEAR THE RATE ACCUMULATOR.

      RATOUT=0

C

C2------IF CELL-BY-CELL FLOW TERMS WILL BE SAVED THEN CLEAR THE BUFFER.

      IBD=0

      IF(IEVTCB.LE.0 .OR. ICBCFL.EQ.0) GO TO 5

      IBD=1

      DO 4 IL=1,NLAY

      DO 4 IR=1,NROW

      DO 4 IC=1,NCOL

      BUFF(IC,IR,IL)=0.

    4 CONTINUE

C

C3------PROCESS EACH HORIZONTAL CELL LOCATION

    5 DO 10 IR=1,NROW

      DO 10 IC=1,NCOL

C

C4------SET THE LAYER INDEX EQUAL TO 1      .

      IL=1

C

C5------IF OPTION 2 IS SPECIFIED THEN GET LAYER INDEX FROM IEVT ARRAY

      IF(NEVTOP.EQ.2)IL=IEVT(IC,IR)

C

C6------IF CELL IS EXTERNAL THEN IGNORE IT.

      IF(IBOUND(IC,IR,IL).LE.0)GO TO 10

      C=EVTR(IC,IR)

      S=SURF(IC,IR)

      H=HNEW(IC,IR,IL)

C

C7------IF AQUIFER HEAD => SURF,SET Q=MAX ET RATE

      IF(H.LT.S) GO TO 7

      Q=-C

      GO TO 9

C

C8------IF DEPTH=>EXTINCTION DEPTH, ET IS 0

    7 X=EXDP(IC,IR)

      D=S-H

      IF(D.GE.X)GO TO 10

C

C9------LINEAR RANGE . Q=-EVTR(H-EXEL)/EXDP

      Q=C*D/X-C

C

C10-----ACCUMULATE TOTAL FLOW RATE

    9 RATOUT=RATOUT-Q

C

C11-----IF CELL-BY-CELL FLOW TERMS TO BE SAVED THE ADD Q TO BUFFER.

      IF(IBD.EQ.1) BUFF(IC,IR,IL)=Q

   10 CONTINUE

C

C12-----IF C-B-C TO BE SAVED CALL MODULE UBUDSV TO RECORD THEM.

      IF(IBD.EQ.1) CALL UBUDSV(KSTP,KPER,TEXT,IEVTCB,BUFF,NCOL,NROW,

     1                          NLAY,IOUT)

C

C13-----MOVE TOTAL ET RATE INTO VBVL FOR PRINTING BY BAS1OT.

      VBVL(3,MSUM)=0.

      VBVL(4,MSUM)=RATOUT

C

C14-----ADD ET(ET_RATE TIMES STEP LENGTH) TO VBVL

      VBVL(1,MSUM)=0.

      VBVL(2,MSUM)=VBVL(2,MSUM)+RATOUT*DELT

C

C15-----MOVE BUDGET TERM LABELS TO VBNM FOR PRINT BY MODULE BAS1OT

      VBNM(1,MSUM)=TEXT(1)

      VBNM(2,MSUM)=TEXT(2)

      VBNM(3,MSUM)=TEXT(3)

      VBNM(4,MSUM)=TEXT(4)

C

C16-----INCREMENT BUDGET TERM COUNTER

      MSUM=MSUM+1

C

C17-----RETURN

      RETURN

      END

