      SUBROUTINE RCH1AL(ISUM,LENX,LCIRCH,LCRECH,NRCHOP,

     1                  NCOL,NROW,IN,IOUT,IRCHCB)

C

C-----VERSION 1559 12MAY1987 RCH1AL

C     ******************************************************************

C     ALLOCATE ARRAY STORAGE FOR RECHARGE

C     ******************************************************************

C

C        SPECIFICATIONS:

C     ------------------------------------------------------------------

C     ------------------------------------------------------------------

C

C1------IDENTIFY PACKAGE.

      WRITE(IOUT,1)IN

    1 FORMAT(1H0,'RCH1 -- RECHARGE PACKAGE, VERSION 1, 9/1/87',

     1' INPUT READ FROM UNIT',I3)

C

C2------READ NRCHOP AND IRCHCB.

      READ(IN,2)NRCHOP,IRCHCB

    2 FORMAT(2I10)

C

C3------CHECK TO SEE THAT OPTION IS LEGAL.

      IF(NRCHOP.GE.1.AND.NRCHOP.LE.3)GO TO 200

C

C3A-----IF ILLEGAL PRINT A MESSAGE AND ABORT SIMULATION

      WRITE(IOUT,8)

    8 FORMAT(1X,'ILLEGAL OPTION CODE. SIMULATION ABORTING')

      STOP

C

C4------IF OPTION IS LEGAL PRINT OPTION CODE.

  200 IRK=ISUM

      IF(NRCHOP.EQ.1) WRITE(IOUT,201)

  201 FORMAT(1X,'OPTION 1 -- RECHARGE TO TOP LAYER')

      IF(NRCHOP.EQ.2) WRITE(IOUT,202)

  202 FORMAT(1X,'OPTION 2 -- RECHARGE TO ONE SPECIFIED NODE IN EACH',

     1        ' VERTICAL COLUMN')

      IF(NRCHOP.EQ.3) WRITE(IOUT,203)

  203 FORMAT(1X,'OPTION 3 -- RECHARGE TO HIGHEST ACTIVE NODE IN EACH',

     1        ' VERTICAL COLUMN')

C

C5------IF CELL-BY-CELL FLOW  TERMS TO BE SAVED THEN PRINT UNIT #

      IF(IRCHCB.GT.0) WRITE(IOUT,204) IRCHCB

  204 FORMAT(1X,'CELL-BY-CELL FLOW TERMS WILL BE RECORDED ON UNIT',I3)

C

C6------ALLOCATE SPACE FOR THE RECHARGE ARRAY(RECH).

      LCRECH=ISUM

      ISUM=ISUM+NCOL*NROW

C

C7------IF OPTION 2 THEN ALLOCATE SPACE FOR INDICATOR ARRAY(IRCH)

      LCIRCH=ISUM

      IF(NRCHOP.NE.2)GO TO 300

      ISUM=ISUM+NCOL*NROW

C

C8------CALCULATE AND PRINT AMOUNT OF SPACE USED BY RECHARGE.

  300 IRK=ISUM-IRK

      WRITE(IOUT,4)IRK

    4 FORMAT(1X,I8,' ELEMENTS OF X ARRAY USED FOR RECHARGE')

      ISUM1=ISUM-1

      WRITE(IOUT,5)ISUM1,LENX

    5 FORMAT(1X,I8,' ELEMENTS OF X ARRAY USED OUT OF',I8)

      IF(ISUM1.GT.LENX)WRITE(IOUT,6)

    6 FORMAT(1X,'   ***X ARRAY MUST BE MADE LARGER***')

C

C9------RETURN

      RETURN

      END

      SUBROUTINE RCH1RP(NRCHOP,IRCH,RECH,DELR,DELC,NROW,NCOL,

     1                  IN,IOUT)

C

C-----VERSION 1634 24JUL1987 RCH1RP

C     ******************************************************************

C     READ RECHARGE RATES

C     ******************************************************************

C

C        SPECIFICATIONS:

C     ------------------------------------------------------------------

      CHARACTER*4 ANAME

      DIMENSION IRCH(NCOL,NROW),RECH(NCOL,NROW),

     1          ANAME(6,2),DELR(NCOL),DELC(NROW)

C

      DATA ANAME(1,1),ANAME(2,1),ANAME(3,1),ANAME(4,1),ANAME(5,1),

     1  ANAME(6,1) /'    ','RECH','ARGE',' LAY','ER I','NDEX'/

      DATA ANAME(1,2),ANAME(2,2),ANAME(3,2),ANAME(4,2),ANAME(5,2),

     1  ANAME(6,2) /'    ','    ','    ','    ','RECH','ARGE'/

C     ------------------------------------------------------------------

C

C1------READ FLAGS SHOWING WHETHER DATA IS TO BE REUSED.

      READ(IN,4)INRECH,INIRCH

    4 FORMAT(2I10)

C

C2------TEST INRECH TO SEE WHERE RECH IS COMING FROM.

      IF(INRECH.GE.0)GO TO 32

C

C2A-----IF INRECH<0 THEN REUSE RECHARGE ARRAY FROM LAST STRESS PERIOD

      WRITE(IOUT,3)

    3 FORMAT(1H0,'REUSING RECH FROM LAST STRESS PERIOD')

      GO TO 55

C

C3------IF INRECH=>0 THEN CALL U2DREL TO READ RECHARGE RATE.

   32 CALL U2DREL(RECH,ANAME(1,2),NROW,NCOL,0,IN,IOUT)

C

C4------MULTIPLY RECHARGE RATE BY CELL AREA TO GET VOLUMETRIC RATE.

      DO 50 IR=1,NROW

      DO 50 IC=1,NCOL

      RECH(IC,IR)=RECH(IC,IR)*DELR(IC)*DELC(IR)

   50 CONTINUE

C

C5------IF NRCHOP=2 THEN A LAYER INDICATOR ARRAY IS NEEDED.

  55  IF (NRCHOP.NE.2)GO TO 60

C

C6------IF INIRCH<0 THEN REUSE LAYER INDICATOR ARRAY.

      IF(INIRCH.GE.0)GO TO 58

      WRITE(IOUT,2)

    2 FORMAT(1H0,'REUSING IRCH FROM LAST STRESS PERIOD')

      GO TO 60

C

C7------IF INIRCH=>0 CALL U2DINT TO READ LAYER IND ARRAY(IRCH)

   58 CALL U2DINT(IRCH,ANAME(1,1),NROW,NCOL,0,IN,IOUT)

C

C8------RETURN

   60 RETURN

      END

      SUBROUTINE RCH1FM(NRCHOP,IRCH,RECH,RHS,IBOUND,NCOL,

     1                     NROW,NLAY)

C

C-----VERSION 1404 12MAY1987 RCH1FM

C     ******************************************************************

C     SUBTRACT RECHARGE FROM RHS

C     ******************************************************************

C

C        SPECIFICATIONS:

C     ------------------------------------------------------------------

      DIMENSION IRCH(NCOL,NROW),RECH(NCOL,NROW),

     1          RHS(NCOL,NROW,NLAY),IBOUND(NCOL,NROW,NLAY)

C     ------------------------------------------------------------------

C

C1------IF NRCHOP IS 1 RECHARGE IS IN TOP LAYER. LAYER INDEX IS 1.

      IF(NRCHOP.NE.1) GO TO 15

C

      DO 10 IR=1,NROW

      DO 10 IC=1,NCOL

C

C1A-----IF CELL IS EXTERNAL THERE IS NO RECHARGE INTO IT.

      IF(IBOUND(IC,IR,1).LE.0)GO TO 10

C

C1B-----SUBTRACT RECHARGE RATE FROM RIGHT-HAND-SIDE.

      RHS(IC,IR,1)=RHS(IC,IR,1)-RECH(IC,IR)

   10 CONTINUE

      GO TO 100

C

C2------IF OPTION IS 2 THEN RECHARGE IS INTO LAYER IN INDICATOR ARRAY

   15 IF(NRCHOP.NE.2)GO TO 25

      DO 20 IR=1,NROW

      DO 20 IC=1,NCOL

C

C2A-----LAYER INDEX IS IN INDICATOR ARRAY.

      IL=IRCH(IC,IR)

C

C2B-----IF THE CELL IS EXTERNAL THERE IS NO RECHARGE INTO IT.

      IF(IBOUND(IC,IR,IL).LE.0)GO TO 20

C

C2C-----SUBTRACT RECHARGE FROM RIGHT-HAND-SIDE.

      RHS(IC,IR,IL)=RHS(IC,IR,IL)-RECH(IC,IR)

   20 CONTINUE

      GO TO 100

C

C3------IF OPTION IS 3 RECHARGE IS INTO HIGHEST INTERNAL CELL.

   25 IF(NRCHOP.NE.3)GO TO 100

C        CANNOT PASS THROUGH CONSTANT HEAD NODE

      DO 30 IR=1,NROW

      DO 30 IC=1,NCOL

      DO 28 IL=1,NLAY

C

C3A-----IF CELL IS CONSTANT HEAD MOVE ON TO NEXT HORIZONTAL LOCATION.

      IF(IBOUND(IC,IR,IL).LT.0) GO TO 30

C

C3B-----IF CELL IS INACTIVE MOVE DOWN A LAYER.

      IF (IBOUND(IC,IR,IL).EQ.0)GO TO 28

C

C3C-----SUBTRACT RECHARGE FROM RIGHT-HAND-SIDE.

      RHS(IC,IR,IL)=RHS(IC,IR,IL)-RECH(IC,IR)

      GO TO 30

   28 CONTINUE

   30 CONTINUE

  100 CONTINUE

C

C4------RETURN

      RETURN

      END

      SUBROUTINE RCH1BD(NRCHOP,IRCH,RECH,IBOUND,NROW,NCOL,NLAY,

     1    DELT,VBVL,VBNM,MSUM,KSTP,KPER,IRCHCB,ICBCFL,BUFF,IOUT)

C

C-----VERSION 1602 12MAY1987 RCH1BD

C     ******************************************************************

C     CALCULATE VOLUMETRIC BUDGET FOR RECHARGE

C     ******************************************************************

C

C        SPECIFICATIONS:

C     ------------------------------------------------------------------

      CHARACTER*4 VBNM,TEXT

      DIMENSION IRCH(NCOL,NROW),RECH(NCOL,NROW),

     1          IBOUND(NCOL,NROW,NLAY),BUFF(NCOL,NROW,NLAY),

     2          VBVL(4,20),VBNM(4,20)

      DIMENSION TEXT(4)

      DATA TEXT(1),TEXT(2),TEXT(3),TEXT(4) /'    ','    ','RECH','ARGE'/

C     ------------------------------------------------------------------

C

C1------CLEAR THE RATE ACCUMULATORS.

      RATIN=0.

      RATOUT=0.

C

C2------IF CELL-BY-CELL FLOW TERMS WILL BE SAVED THEN CLEAR THE BUFFER.

      IBD=0

      IF(ICBCFL.EQ.0 .OR. IRCHCB.LE.0) GO TO 5

      IBD=1

      DO 2 IL=1,NLAY

      DO 2 IR=1,NROW

      DO 2 IC=1,NCOL

      BUFF(IC,IR,IL)=0.

    2 CONTINUE

C

C3------IF NRCHOP=1 RECH GOES INTO LAYER 1. PROCESS EACH HORIZONTAL

C3------CELL LOCATION.

    5 IF(NRCHOP.NE.1) GO TO 15

C

C     ---RECHARGE IS APPLIED TO TOP LAYER

      DO 10 IR=1,NROW

      DO 10 IC=1,NCOL

C

C3A-----IF CELL IS EXTERNAL THEN DO NOT DO BUDGET FOR IT.

      IF(IBOUND(IC,IR,1).LE.0)GO TO 10

      Q=RECH(IC,IR)

C

C3B-----IF CELL-BY-CELL FLOW TERMS WILL BE SAVED THEN ADD RECH TO BUFF

      IF(IBD.EQ.1) BUFF(IC,IR,1)=Q

C

C3C-----IF RECH POSITIVE ADD IT TO RATIN ELSE ADD IT TO RATOUT.

      IF(Q) 8,10,7

    7 RATIN=RATIN+Q

      GO TO 10

    8 RATOUT=RATOUT-Q

   10 CONTINUE

      GO TO 100

C

C4------IF NRCHOP=2 RECH IS IN LAYER SHOWN IN INDICATOR ARRAY(IRCH).

C4------PROCESS HORIZONTAL CELL LOCATIONS ONE AT A TIME.

   15 IF(NRCHOP.NE.2)GO TO 25

      DO 20 IR=1,NROW

      DO 20 IC=1,NCOL

C

C4A-----GET LAYER INDEX FROM INDICATOR ARRAY(IRCH).

      IL=IRCH(IC,IR)

C

C4B-----IF CELL IS EXTERNAL DO NOT CALCULATE BUDGET FOR IT.

      IF(IBOUND(IC,IR,IL).LE.0)GO TO 20

      Q=RECH(IC,IR)

C

C4C-----IF C-B-C FLOW TERMS WILL BE SAVED THEN ADD RECHARGE TO BUFFER.

      IF(IBD.EQ.1) BUFF(IC,IR,IL)=Q

C

C4D-----IF RECHARGE IS POSITIVE ADD TO RATIN ELSE ADD IT TO RATOUT.

      IF(Q) 18,20,17

   17 RATIN=RATIN+Q

      GO TO 20

   18 RATOUT=RATOUT-Q

   20 CONTINUE

      GO TO 100

C

C5------IF OPTION=3 RECHARGE IS INTO HIGHEST INTERNAL CELL. IT WILL NOT

C5------PASS THROUGH A CONSTANT HEAD CELL. PROCESS HORIZONTAL CELL

C5------LOCATIONS ONE AT A TIME.

   25 IF(NRCHOP.NE.3)GO TO 100

      DO 30 IR=1,NROW

      DO 30 IC=1,NCOL

      DO 28 IL=1,NLAY

C

C5A-----IF CELL IS CONSTANT HEAD MOVE ON TO NEXT HORIZONTAL LOCATION.

      IF(IBOUND(IC,IR,IL).LT.0) GO TO 30

C

C5B-----IF CELL IS INACTIVE MOVE DOWN TO NEXT CELL.

      IF (IBOUND(IC,IR,IL).EQ.0)GO TO 28

      Q=RECH(IC,IR)

C

C5C-----IF C-B-C FLOW TERMS TO BE SAVED THEN ADD RECHARGE TO BUFFER.

      IF(IBD.EQ.1) BUFF(IC,IR,IL)=Q

C

C5D-----IF RECH IS POSITIVE ADD IT TO RATIN ELSE ADD IT TO RATOUT.

      IF(Q) 27,30,26

   26 RATIN=RATIN+Q

      GO TO 30

   27 RATOUT=RATOUT-Q

      GO TO 30

   28 CONTINUE

   30 CONTINUE

C

  100 CONTINUE

C

C6------IF C-B-C FLOW TERMS TO BE SAVED CALL UBUDSV TO WRITE THEM.

      IF(IBD.EQ.1) CALL UBUDSV(KSTP,KPER,TEXT,IRCHCB,BUFF,NCOL,NROW,

     1                          NLAY,IOUT)

C

C7------MOVE TOTAL RECHARGE RATE INTO VBVL FOR PRINTING BY BAS1OT.

      VBVL(4,MSUM)=RATOUT

      VBVL(3,MSUM)=RATIN

C

C8------ADD RECHARGE FOR TIME STEP TO RECHARGE ACCUMULATOR IN VBVL.

      VBVL(2,MSUM)=VBVL(2,MSUM)+RATOUT*DELT

      VBVL(1,MSUM)=VBVL(1,MSUM)+RATIN*DELT

C

C9------MOVE BUDGET TERM LABELS TO VBNM FOR PRINT BY MODULE BAS_OT.

      VBNM(1,MSUM)=TEXT(1)

      VBNM(2,MSUM)=TEXT(2)

      VBNM(3,MSUM)=TEXT(3)

      VBNM(4,MSUM)=TEXT(4)

C

C10-----INCREMENT BUDGET TERM COUNTER.

      MSUM=MSUM+1

C

C11-----RETURN

      RETURN

      END

