      SUBROUTINE WEL1AL(ISUM,LENX,LCWELL,MXWELL,NWELLS,IN,IOUT,

     1                       IWELCB)

C

C-----VERSION 1538 12MAY1987 WEL1AL

C     ******************************************************************

C     ALLOCATE ARRAY STORAGE FOR WELL PACKAGE

C     ******************************************************************

C

C        SPECIFICATIONS:

C     ------------------------------------------------------------------

C     ------------------------------------------------------------------

C

C1------IDENTIFY PACKAGE AND INITIALIZE NWELLS

      WRITE(IOUT,1)IN

    1 FORMAT(1H0,'WEL1 -- WELL PACKAGE, VERSION 1, 9/1/87',

     1' INPUT READ FROM',I3)

      NWELLS=0

C

C2------READ MAX NUMBER OF WELLS AND

C2------UNIT OR FLAG FOR CELL-BY-CELL FLOW TERMS.

      READ(IN,2) MXWELL,IWELCB

    2 FORMAT(2I10)

      WRITE(IOUT,3) MXWELL

    3 FORMAT(1H ,'MAXIMUM OF',I5,' WELLS')

      IF(IWELCB.GT.0) WRITE(IOUT,9) IWELCB

    9 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE RECORDED ON UNIT',I3)

      IF(IWELCB.LT.0) WRITE(IOUT,8)

    8 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE PRINTED WHEN ICBCFL NOT 0')

C

C3------SET LCWELL EQUAL TO LOCATION OF WELL LIST IN X ARRAY.

      LCWELL=ISUM

C

C4------ADD AMOUNT OF SPACE USED BY WELL LIST TO ISUM.

      ISP=4*MXWELL

      ISUM=ISUM+ISP

C

C5------PRINT NUMBER OF SPACES IN X ARRAY USED BY WELL PACKAGE.

      WRITE(IOUT,4) ISP

    4 FORMAT(1X,I8,' ELEMENTS IN X ARRAY ARE USED FOR WELLS')

      ISUM1=ISUM-1

      WRITE(IOUT,5) ISUM1,LENX

    5 FORMAT(1X,I8,' ELEMENTS OF X ARRAY USED OUT OF',I8)

C

C6------IF THERE ISN'T ENOUGH SPACE IN THE X ARRAY THEN PRINT

C6------A WARNING MESSAGE.

      IF(ISUM1.GT.LENX) WRITE(IOUT,6)

    6 FORMAT(1X,'   ***X ARRAY MUST BE DIMENSIONED LARGER***')

C7------RETURN

      RETURN

      END

      SUBROUTINE WEL1RP(WELL,NWELLS,MXWELL,IN,IOUT)

C

C

C-----VERSION 1544 22DEC1982 WEL1RP

C     ******************************************************************

C     READ NEW WELL LOCATIONS AND STRESS RATES

C     ******************************************************************

C

C        SPECIFICATIONS:

C     ------------------------------------------------------------------

      DIMENSION WELL(4,MXWELL)

C     ------------------------------------------------------------------

C

C1------READ ITMP(NUMBER OF WELLS OR FLAG SAYING REUSE WELL DATA)

      READ (IN,1) ITMP

    1 FORMAT(I10)

      IF(ITMP.GE.0) GO TO 50

C

C1A-----IF ITMP LESS THAN ZERO REUSE DATA. PRINT MESSAGE AND RETURN.

      WRITE(IOUT,6)

    6 FORMAT(1H0,'REUSING WELLS FROM LAST STRESS PERIOD')

      RETURN

C

C1B-----ITMP=>0.  SET NWELLS EQUAL TO ITMP.

   50 NWELLS=ITMP

      IF(NWELLS.LE.MXWELL) GO TO 100

C

C2------NWELLS>MXWELL.  PRINT MESSAGE. STOP.

      WRITE(IOUT,99) NWELLS,MXWELL

   99 FORMAT(1H0,'NWELLS(',I4,') IS GREATER THAN MXWELL(',I4,')')

      STOP

C

C3------PRINT NUMBER OF WELLS IN CURRENT STRESS PERIOD.

  100 WRITE (IOUT,2) NWELLS

    2 FORMAT(1H0,10X,I4,' WELLS')

C

C4------IF THERE ARE NO ACTIVE WELLS IN THIS STRESS PERIOD THEN RETURN

      IF(NWELLS.EQ.0) GO TO 260

C

C5------READ AND PRINT LAYER,ROW,COLUMN AND RECHARGE RATE.

      WRITE(IOUT,3)

    3 FORMAT(1H ,47X,'LAYER    ROW    COL    STRESS RATE   WELL NO.'/

     1,48X,45('-'))

      DO 250 II=1,NWELLS

      READ (IN,4) K,I,J,Q

    4 FORMAT(3I10,F10.0)

      WRITE (IOUT,5) K,I,J,Q,II

    5 FORMAT(48X,I3,I8,I7,G16.5,I8)

      WELL(1,II)=K

      WELL(2,II)=I

      WELL(3,II)=J

      WELL(4,II)=Q

  250 CONTINUE

C

C6------RETURN

  260 RETURN

      END

      SUBROUTINE WEL1FM(NWELLS,MXWELL,RHS,WELL,IBOUND,

     1        NCOL,NROW,NLAY)

C

C-----VERSION 1233 12MAY1987 WEL1FM

C

C     ******************************************************************

C     SUBTRACT Q FROM RHS

C     ******************************************************************

C

C        SPECIFICATIONS:

C     ------------------------------------------------------------------

      DIMENSION RHS(NCOL,NROW,NLAY),WELL(4,MXWELL),

     1            IBOUND(NCOL,NROW,NLAY)

C     ------------------------------------------------------------------

C1------IF NUMBER OF WELLS <= 0 THEN RETURN.

      IF(NWELLS.LE.0) RETURN

C

C2------PROCESS EACH WELL IN THE WELL LIST.

      DO 100 L=1,NWELLS

      IR=WELL(2,L)

      IC=WELL(3,L)

      IL=WELL(1,L)

      Q=WELL(4,L)

C

C2A-----IF THE CELL IS INACTIVE THEN BYPASS PROCESSING.

      IF(IBOUND(IC,IR,IL).LE.0) GO TO 100

C

C2B-----IF THE CELL IS VARIABLE HEAD THEN SUBTRACT Q FROM

C       THE RHS ACCUMULATOR.

      RHS(IC,IR,IL)=RHS(IC,IR,IL)-Q

  100 CONTINUE

C

C3------RETURN

      RETURN

      END

      SUBROUTINE WEL1BD(NWELLS,MXWELL,VBNM,VBVL,MSUM,WELL,IBOUND,DELT,

     1             NCOL,NROW,NLAY,KSTP,KPER,IWELCB,ICBCFL,BUFF,IOUT)

C

C-----VERSION 1509 12MAY1987 WEL1BD

C     ******************************************************************

C     CALCULATE VOLUMETRIC BUDGET FOR WELLS

C     ******************************************************************

C

C        SPECIFICATIONS:

C     ------------------------------------------------------------------

      CHARACTER*4 VBNM,TEXT

      DIMENSION VBNM(4,MSUM),VBVL(4,MSUM),WELL(4,MXWELL),

     1          IBOUND(NCOL,NROW,NLAY),BUFF(NCOL,NROW,NLAY)

      DIMENSION TEXT(4)

C

      DATA TEXT(1),TEXT(2),TEXT(3),TEXT(4) /'    ','    ','   W','ELLS'/

C     ------------------------------------------------------------------

C

C1------CLEAR RATIN AND RATOUT ACCUMULATORS.

      RATIN=0.

      RATOUT=0.

      IBD=0

C

C2------IF THERE ARE NO WELLS DO NOT ACCUMULATE FLOW

      IF(NWELLS.EQ.0) GO TO 200

C

C3------TEST TO SEE IF CELL-BY-CELL FLOW TERMS WILL BE RECORDED.

      IF(ICBCFL.EQ.0 .OR. IWELCB.LE.0) GO TO 60

C

C4------IF CELL-BY-CELL FLOWS WILL BE SAVED THEN CLEAR THE BUFFER.

      IBD=1

      DO 50 IL=1,NLAY

      DO 50 IR=1,NROW

      DO 50 IC=1,NCOL

      BUFF(IC,IR,IL)=0.

   50 CONTINUE

C

C5------PROCESS WELLS ONE AT A TIME.

   60 DO 100 L=1,NWELLS

      IR=WELL(2,L)

      IC=WELL(3,L)

      IL=WELL(1,L)

      Q=WELL(4,L)

C

C5A-----IF THE CELL IS EXTERNAL IGNORE IT.

      IF(IBOUND(IC,IR,IL).LE.0)GO TO 100

C

C5B-----PRINT THE INDIVIDUAL RATES IF REQUESTED(IWELCB<0).

      IF(IWELCB.LT.0.AND.ICBCFL.NE.0) WRITE(IOUT,900) (TEXT(N),N=1,4),

     1    KPER,KSTP,L,IL,IR,IC,Q

  900 FORMAT(1H0,4A4,'   PERIOD',I3,'   STEP',I3,'   WELL',I4,

     1    '   LAYER',I3,'   ROW ',I4,'   COL',I4,'   RATE',G15.7)

C

C5C-----IF CELL-BY-CELL FLOWS ARE TO BE SAVED THEN ADD THEM TO BUFFER.

      IF(IBD.EQ.1) BUFF(IC,IR,IL)=BUFF(IC,IR,IL)+Q

      IF(Q) 90,100,80

C

C5D-----PUMPING RATE IS POSITIVE(RECHARGE). ADD IT TO RATIN.

   80 RATIN=RATIN+Q

      GO TO 100

C

C5E-----PUMPING RATE IS NEGATIVE(DISCHARGE). ADD IT TO RATOUT.

   90 RATOUT=RATOUT-Q

  100 CONTINUE

C

C6------IF CELL-BY-CELL FLOWS WILL BE SAVED CALL UBUDSV TO RECORD THEM

      IF(IBD.EQ.1) CALL UBUDSV(KSTP,KPER,TEXT,IWELCB,BUFF,NCOL,NROW,

     1                          NLAY,IOUT)

C

C7------MOVE RATES INTO VBVL FOR PRINTING BY MODULE BAS1OT.

  200 VBVL(3,MSUM)=RATIN

      VBVL(4,MSUM)=RATOUT

C

C8------MOVE RATES TIMES TIME STEP LENGTH INTO VBVL ACCUMULATORS.

      VBVL(1,MSUM)=VBVL(1,MSUM)+RATIN*DELT

      VBVL(2,MSUM)=VBVL(2,MSUM)+RATOUT*DELT

C

C9------MOVE BUDGET TERM LABELS INTO VBNM FOR PRINTING.

      VBNM(1,MSUM)=TEXT(1)

      VBNM(2,MSUM)=TEXT(2)

      VBNM(3,MSUM)=TEXT(3)

      VBNM(4,MSUM)=TEXT(4)

C

C10-----INCREMENT BUDGET TERM COUNTER(MSUM).

      MSUM=MSUM+1

C

C11-----RETURN

      RETURN

      END

